Name: starbridge
Version: 5.0.215
Release: 1%{?dist}
Summary: WhiteStar StarBridge Service
License: GPL

Source0: https://whitestar.io/repo/starbridge/5.0.008/5.0.215/starbridge.tar.xz
BuildArch: noarch
ExclusiveArch: %{nodejs_arches} noarch
BuildRequires: make

Requires: telnet

%description
WhiteStar StarBridge Service

%prep
%autosetup -n %{name}

%build
ESLINT=0 NODE_ENV=production make

%install
make install-service DESTDIR=%{buildroot} PREFIX=/home/whitestar/starbridge

%files
%doc README.md
%attr(0744, whitestar, whitestar) /home/whitestar/starbridge/*
%attr(0744, whitestar, whitestar) /home/whitestar/starbridge/dist/*
%attr(0755, whitestar, whitestar) /home/whitestar/starbridge/dist/libs/*

# Script to be run after package is installed
%post
#
# Create the user: whitestar with password whitestar and admin privileges
# password is encrypted below using crypt() command outside this routine
#
# perl -e 'print crypt("whitestar", "salt"),"\n"'
#
echo "##"
echo "## Creating whitestar userid...and giving it admin authority"
echo "##"
id -u whitestar || (
  echo "Creating new User: whitestar"
  useradd -m -p saVcBwwVb0fMY whitestar
)
usermod -aG wheel whitestar
chown -R whitestar /home/whitestar/starbridge
chown -R whitestar /home/whitestar/starbridge/dist

# if java 21 folder is not installed, install it
if [ ! -d /opt/jdk-21.0.1 ]; then
  echo "##"
  echo "## Installing Java 21.0.1"
  echo "##"
  cd /tmp
  wget -c https://cdn.azul.com/zulu/bin/zulu21.30.15-ca-fx-jdk21.0.1-linux_x64.tar.gz
  tar xzf zulu21.30.15-ca-fx-jdk21.0.1-linux_x64.tar.gz
  mv zulu21.30.15-ca-fx-jdk21.0.1-linux_x64  /opt/jdk-21.0.1
fi

if [ ! -e /etc/systemd/system/starbridge.service ]; then
  echo "##"
  echo "## Creating the StarBridge Service"
  echo "##"
  cat > /etc/systemd/system/starbridge.service <<EOF
  [Unit]
  Description = WhiteStar Shell
  After=network-online.target iscsid.service mnt.mount
  [Service]
  WorkingDirectory=/home/whitestar/starbridge/dist
  ExecStart=/opt/jdk-21.0.1/bin/java -XX:+UseStringDeduplication -Dpty=true -jar starBridge.jar 
  User=whitestar
  Type=simple
  Restart=on-failure
  RestartSec=10
  [Install]
  WantedBy=multi-user.target
EOF
fi
 
#
# Enable the StarBridge Service - if we choose to start verify it is running
#
echo "##"
echo "## Enable the StarBridge Service"
echo "##"
systemctl daemon-reload
systemctl enable starbridge.service
systemctl restart starbridge.service

echo "## WhiteStar Shell Service Started!";

# Script to be run after package is un-installed
%postun
# $1 variable determines whether this is an upgrade ($1 == 1) or uninstall ($1 == 0)
# if set to uninstall, remove the starbridge service
if [ $1 -eq 0 ] ; then
  rm -f /etc/systemd/system/starbridge.service;
  systemctl stop starbridge.service;
  systemctl disable starbridge.service;
  systemctl daemon-reload;
fi

%changelog
